Magellan Linux

Diff of /trunk/installer-simple/bin/installer.sh.in

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 2480 by niro, Wed Jan 8 10:25:50 2014 UTC revision 2883 by niro, Fri Jul 31 09:42:12 2015 UTC
# Line 9  Line 9 
9    
10  # setup locales  # setup locales
11  TEXTDOMAIN=installer  TEXTDOMAIN=installer
 LC_MESSAGES=C  
12    
13  # include dir  # include dir
14  INSTALLER_LIBDIR="%LIBDIR%"  INSTALLER_LIBDIR="%LIBDIR%"
# Line 41  do Line 40  do
40   fi   fi
41  done  done
42    
 # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !  
 # -> now in images.conf  
 CDIMAGENAME=""  
 TOTALLINES=""  
 CURRENTLINE=0  
 if [ -e /mnt/cdrom/system/images.conf ]  
 then  
  source /mnt/cdrom/system/images.conf  
  # check if all required variables are set  
  [[ -z ${CDIMAGENAME} ]] && die "CDIMAGENAME is empty in /mnt/cdrom/system/images.conf"  
  [[ -z ${TOTALLINES} ]] && die "TOTALLINES is empty in /mnt/cdrom/system/images.conf"  
 else  
  die "/mnt/cdrom/system/images.conf not found"  
 fi  
   
43  ### System/Config Version  ### System/Config Version
44  VERSION="%VERSIONTAG%"  VERSION="%VERSIONTAG%"
45  TITLE="${DEFAULT_TITLE} - ${VERSION}"  TITLE="${DEFAULT_TITLE} - ${VERSION}"
46    
47  # some sane defaults  # some sane defaults
48  CDROOT="${DEFAULT_CDROOT}"  LIVEROOT="${DEFAULT_LIVEROOT}"
49    IMAGEROOT="${DEFAULT_IMAGEROOT}"
50  INSTALLROOT="${DEFAULT_INSTALLROOT}"  INSTALLROOT="${DEFAULT_INSTALLROOT}"
51  KERNELPKG="${DEFAULT_KERNELPKG}"  KERNELPKG="${DEFAULT_KERNELPKG}"
52  KERNELOPTS="${DEFAULT_KERNELOPTS}"  KERNELOPTS="${DEFAULT_KERNELOPTS}"
# Line 72  SPECIALDEVICE="" Line 57  SPECIALDEVICE=""
57  FORMFACTOR="${DEFAULT_FORMFACTOR}"  FORMFACTOR="${DEFAULT_FORMFACTOR}"
58  FORMAT_FILESYSTEM="${DEFAULT_FILESYSTEM}"  FORMAT_FILESYSTEM="${DEFAULT_FILESYSTEM}"
59    
60  #################################################  # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !
61  #  DIALOG BOXEN #  # -> now in images.conf
62  #################################################  CDIMAGENAME=""
63    TOTALLINES=""
64    CURRENTLINE=0
65    if [ -e ${IMAGEROOT}/images.conf ]
66    then
67     source ${IMAGEROOT}/images.conf
68     # check if all required variables are set
69     [[ -z ${CDIMAGENAME} ]] && die "CDIMAGENAME is empty in ${IMAGEROOT}/images.conf"
70     [[ -z ${TOTALLINES} ]] && die "TOTALLINES is empty in ${IMAGEROOT}/images.conf"
71    else
72     die "${IMAGEROOT}/images.conf not found"
73    fi
74    
75    ### helper scripts ###
76    
77  trap_exit()  trap_exit()
78  {  {
# Line 88  trap_exit() Line 86  trap_exit()
86   exit 1   exit 1
87  }  }
88    
89  dialog_die()  install_meter()
 {  
  ERROR="$1"  
  RETVAL="$?"  
  dialog_install_failure  
  exit 1  
 }  
   
 dialog_warning()  
90  {  {
91   local retval   while [[ ${CURRENTLINE} != ${TOTALLINES} ]]
92     do
93   yesnobox $"\Z1 !!! Warning !!! \Zn\n\n\This harddrive will be irreversibly erased.\n\n\Do you want to continue ?"   CURRENTLINE=$(grep -c . /tmp/install.log)
94   retval=$?   PERCENT=$(( ${CURRENTLINE} * 100 / ${TOTALLINES}))
95   if [[ ${retval} -eq 1 ]]   echo ${PERCENT}
96   then   sleep 1
97   clear   done
98   echo $"The process was aborted."   rm -f /tmp/install.log
99   exit 1   return 0
  fi  
100  }  }
101    
102  task_setup_system_menu()  install_mount_rootfs()
103  {  {
104   local mode   local opts
  local retval  
105    
106   mode="$(dialog_setup_system_menu)"   if [[ -n ${SWAPHDD} ]]
  retval=$?  
  [[ ${retval} -eq 1 ]] && return 1  
  if [[ ${retval} -eq 0 ]]  
107   then   then
108   case "${mode}" in   swapon ${SWAPHDD} || die
  "1") run_install_auto ;;  
  "2") run_install_normal ;;  
  "") task_setup_system_menu;;  
  esac  
109   fi   fi
110  }   if [[ -n ${ROOTHDD} ]]
   
 dialog_hardware_detection()  
 {  
  local message  
   
  run_hardware_detection_disks  
   
  message+=$"Harddrives:\n"  
   
  if [[ ! -z ${ALL_DISKS} ]]  
111   then   then
112   for i in ${ALL_DISKS}   mount -t ${FORMAT_FILESYSTEM_ROOTHDD} ${ROOTHDD} ${INSTALL_ROOT} || die
  do  
  message+="\Z3${i}\Zn "  
  done  
  message+="\n"  
113   fi   fi
114     if [[ -n ${BOOTHDD} ]]
  if [[ ! -z ${ALL_CDROMS} ]]  
115   then   then
116   message+="\n"   install -d ${INSTALL_ROOT}/boot || die
117   message+=$"Optical disk drives:\n"   mount -t ${FORMAT_FILESYSTEM_BOOTHDD} ${BOOTHDD} ${INSTALL_ROOT}/boot || die
  for i in ${ALL_CDROMS}  
  do  
  message+="\Z3${i}\Zn"  
  done  
  message+="\n"  
118   fi   fi
119    
120   # other devices   cd ${INSTALL_ROOT} || die
  run_hardware_detection  
  case "${SPECIALDEVICE}" in  
  zotac*) message+=$"\n\Z2Zotac device detected.\Zn" ;;  
  rangee) message+=$"\n\Z2Rangee device detected.\Zn" ;;  
  maxdata) message+=$"\n\Z2Maxdata device detected.\Zn" ;;  
  *) message+=$"\n\ZnCommon device detected.\Zn" ;;  
  esac  
  if [[ ${FORMFACTOR} = laptop ]]  
  then  
  message+=$"\n\ZnFormfactor Laptop, activating 'ondemand' powersaving mode.\Zn"  
  fi  
   
  messagebox -y 12 -h $"Detected hardware:" "${message}"  
121  }  }
122    
123  task_setup_hdd_partitions_manual()  
124    mount_rootfs()
125  {  {
  local i  
126   local retval   local retval
127    
128   if [[ -z ${ALL_DISKS} ]]   if [[ -n ${SWAPHDD} ]]
129   then   then
130   dialog_no_harddrive_found   swapon ${SWAPHDD} || dialog_die $"Could not enable swap space '${SWAPHDD}'"
131   exit 1   fi
132   else  
133   HDD=$(dialog_select_target_harddrive)   if [[ -n ${ROOTHDD} ]]
134   retval=$?   then
135   [[ ${retval} -eq 1 ]] && return 1   if is_mounted --location "${INSTALLROOT}"
  if [[ ${retval} -eq 0 ]]  
136   then   then
137   dialog_setup_hdd_info   echo $"${INSTALLROOT} already mounted" >&2
138   setup_hdd_partitions_manual   else
139     mount "${ROOTHDD}" "${INSTALLROOT}" || dialog_die $"Could not mount rootfs - drive '${ROOTHDD}' -> '${INSTALLROOT}'"
140   fi   fi
141   fi   fi
 }  
142    
143  task_setup_hdd_partitions_auto()   [[ -d ${INSTALLROOT}/boot ]] || install -d ${INSTALLROOT}/boot
 {  
  local i  
  local retval  
144    
145   if [[ -z ${ALL_DISKS} ]]   if [[ -n ${BOOTHDD} ]]
146   then   then
147   dialog_no_harddrive_found   if is_mounted --location "${INSTALLROOT}"/boot
  exit 1  
  else  
  HDD=$(dialog_select_target_harddrive)  
  retval=$?  
  [[ ${retval} -eq 1 ]] && return 1  
  if [[ ${retval} -eq 0 ]]  
148   then   then
149   dialog_setup_hdd_info_auto   echo $"${INSTALLROOT}/boot already mounted" >&2
150   dialog_setup_hdd_create_partitions   else
151   setup_hdd_partitions_auto   mount "${BOOTHDD}" "${INSTALLROOT}"/boot || dialog_die $"Could not mount bootfs - drive '${BOOTHDD}' -> '${INSTALLROOT}/boot'"
152   fi   fi
153   fi   fi
154  }  }
155    
156  install_meter()  umount_rootfs()
157  {  {
158   while [[ ${CURRENTLINE} != ${TOTALLINES} ]]   is_mounted --location ${INSTALLROOT}/boot && umount ${INSTALLROOT}/boot
159   do   is_mounted --location ${INSTALLROOT} && umount ${INSTALLROOT}
160   CURRENTLINE=$(grep -c . /tmp/install.log)  
161   PERCENT=$(( ${CURRENTLINE} * 100 / ${TOTALLINES}))   if [[ -n ${SWAPHDD} ]]
162   echo ${PERCENT}   then
163   sleep 1   swapoff ${SWAPHDD} || die
164   done   fi
  rm -f /tmp/install.log  
  return 0  
165  }  }
166    
167  task_main()  install_do_reboot()
168  {  {
169   local method=0   reboot
  local retval  
   
  while [[ ${method} -le 2 ]]  
  do  
  method=$(dialog_main)  
  retval=$?  
  [[ ${retval} -eq 1 ]] && exit 1  
  if [[ ${retval} -eq 0 ]]  
  then  
  case ${method} in  
  "1") task_setup_system_menu ;;  
  "2") dialog_hardware_detection ;;  
  "3") install_do_reboot ;;  
  "4") /bin/bash --login -i ;;  
  esac  
  fi  
  done  
170  }  }
171    
 #################################################  
 # Install Komandos #  
 #################################################  
172  run_hardware_detection()  run_hardware_detection()
173  {  {
174   local hwinfo   local hwinfo
175    
176   hwinfo="$(hwinfo --bios --storage --pci --gfxcard --sys)"   hwinfo="$(hwinfo --bios --storage --pci --gfxcard --sys)"
177    
178   ## check for special devices/clients:   # check for special devices/clients:
179   ## if zotac a zotac and the disk is a removeable device, then add rootdelay to kernelcmd   # if zotac a zotac and the disk is a removeable device, then add rootdelay to kernelcmd
180   #local removable=0   local removable=0
181   #if [[ ! -z $(echo "${hwinfo}" | grep -i zotac) ]]   if [[ ! -z $(echo "${hwinfo}" | grep -i zotac) ]]
182   #then   then
183   #for i in /sys/block/[hs]d*/removable   #for i in /sys/block/[hs]d*/removable
184   #do   #do
185   #if [[ $(< ${i}) = 1 ]]   # if [[ $(< ${i}) = 1 ]]
186   #then   # then
187   #removable=1   # removable=1
188   #fi   # fi
189   #done   #done
190   ## smartcard = udevadm info -n /dev/sda -a | grep -i 'configuration.*card'   # smartcard = udevadm info -n /dev/sda -a | grep -i 'configuration.*card'
191    
192   ## only add this for grub legacy, grub2 detect these settings on its own   # only add this for grub legacy, grub2 detect these settings on its own
193   #export GRUBLEGACYOPTS="rootdelay=8"   export GRUBLEGACYOPTS="rootdelay=8"
194   ## there are to zotac types in the wild, nvidia based gfx and intel   # there are to zotac types in the wild, nvidia based gfx and intel
195   #if [[ ! -z $(echo "${hwinfo}" | grep -i nouveau) ]]   if [[ ! -z $(echo "${hwinfo}" | grep -i nouveau) ]]
196   #then   then
197   #export SPECIALDEVICE="zotac_nvidia"   export SPECIALDEVICE="zotac_nvidia"
198   #else   else
199   #export SPECIALDEVICE="zotac_intel"   export SPECIALDEVICE="zotac_intel"
200   #fi   fi
201   #fi   fi
202    
203   # check for special devices/clients:   # check for special devices/clients:
204   # if a rangee and disk ist smaller then 256mb move partion one block further ahead   # if a rangee and disk ist smaller then 256mb move partion one block further ahead
# Line 318  run_hardware_detection_disks() Line 234  run_hardware_detection_disks()
234   # all disks but exclude ramdisks   # all disks but exclude ramdisks
235   export ALL_DISKS=$(get_hwinfo disk | sed '/\/dev\/ram[0-9].*/d')   export ALL_DISKS=$(get_hwinfo disk | sed '/\/dev\/ram[0-9].*/d')
236   # remove the boot device from ALL_DISKS if it was an usbstick   # remove the boot device from ALL_DISKS if it was an usbstick
237   if [[ $(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f3) != iso9660 ]]   if [[ $(grep '[[:space:]]${LIVEROOT}[[:space:]]' /proc/mounts | cut -d' ' -f3) != iso9660 ]]
238   then   then
239   bootdev="$(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f1 | sed 's:[0-9]::g')"   bootdev=$(grep "[[:space:]]${LIVEROOT}[[:space:]]" /proc/mounts | cut -d' ' -f1 | sed 's:[0-9]::g')
240   export ALL_DISKS=$(echo "${ALL_DISKS}" | grep -v "${bootdev}")   export ALL_DISKS=$(echo "${ALL_DISKS}" | grep -v "${bootdev}")
241   fi   fi
242   export ALL_CDROMS="$(get_hwinfo cdrom)"   export ALL_CDROMS="$(get_hwinfo cdrom)"
243  }  }
244    
245  setup_hdd_partitions_auto()  setup_hdd_partitions()
246  {  {
247   ROOTHDD="${HDD}1"   case "${INSTALL_METHOD}" in
248     auto)
249     BOOTHDD=""
250     SWAPHDD=""
251     ROOTHDD="${HDD}1"
252     ;;
253     normal)
254     BOOTHDD="${HDD}1"
255     SWAPHDD="${HDD}2"
256     ROOTHDD="${HDD}3"
257     ;;
258     esac
259    
260   # sanity check - should not happen   # sanity check - should not happen
261   if is_mounted --device "${ROOTHDD}"   if is_mounted --device "${ROOTHDD}"
# Line 336  setup_hdd_partitions_auto() Line 263  setup_hdd_partitions_auto()
263   echo "partition: device ${ROOTHDD} is already mounted, umount it" >&2   echo "partition: device ${ROOTHDD} is already mounted, umount it" >&2
264   umount "${ROOTHDD}"   umount "${ROOTHDD}"
265   fi   fi
266     if [[ -n ${BOOTHDD} ]]
  # run this only if FDISKPARTITIONBELOW256MB is not already 1  
  if [[ ${FDISKPARTIONBELOW256MB} != 1 ]]  
267   then   then
268   if hdd_size_below_256mb ${HDD}   if is_mounted --device "${BOOTHDD}"
269   then   then
270   FDISKPARTIONBELOW256MB=1   echo "partition: device ${BOOTHDD} is already mounted, umount it" >&2
271   else   umount "${BOOTHDD}"
  FDISKPARTIONBELOW256MB=0  
272   fi   fi
273   fi   fi
274    
275   ## delete disk   if [[ ${INSTALL_METHOD} = auto ]]
  dd if=/dev/zero of=${HDD} count=1 &> /dev/null || dialog_die  
   
  if [[ ${FDISKPARTIONBELOW256MB} = 1 ]]  
276   then   then
277   ## setup one bootable partition   # run this only if FDISKPARTITIONBELOW256MB is not already 1
278   #1. n= new disk   if [[ ${FDISKPARTIONBELOW256MB} != 1 ]]
279   #2. p= primary disk   then
280   #3. 1= first partition   if device_minimum_size "${HDD}" 256
281   #4. 2= default sector start // small disk needs more space for grub2 mbr sector   then
282   #5. ''= defaul sector end   FDISKPARTIONBELOW256MB=1
283   #6. a= bootable flag   else
284   #7. 1= boot flag for partition 1   FDISKPARTIONBELOW256MB=0
285   #8. w= write/quit   fi
286   fdisk ${HDD} &> /dev/null << EOF   fi
287    
288     ## delete disk
289     dd if=/dev/zero of=${HDD} count=1 &> /dev/null || dialog_die
290    
291     if [[ ${FDISKPARTIONBELOW256MB} = 1 ]]
292     then
293     ## setup one bootable partition
294     #1. n= new disk
295     #2. p= primary disk
296     #3. 1= first partition
297     #4. 2= default sector start // small disk needs more space for grub2 mbr sector
298     #5. ''= defaul sector end
299     #6. a= bootable flag
300     #7. 1= boot flag for partition 1
301     #8. w= write/quit
302     fdisk ${HDD} &> /dev/null << EOF
303  n  n
304  p  p
305  1  1
# Line 372  a Line 309  a
309  1  1
310  w  w
311  EOF  EOF
312   else   else
313   ## setup one bootable partition   ## setup one bootable partition
314   #1. n= new disk   #1. n= new disk
315   #2. p= primary disk   #2. p= primary disk
316   #3. 1= first partition   #3. 1= first partition
317   #4. ''= default sector start   #4. ''= default sector start
318   #5. ''= defaul sector end   #5. ''= defaul sector end
319   #6. a= bootable flag   #6. a= bootable flag
320   #7. 1= boot flag for partition 1   #7. 1= boot flag for partition 1
321   #8. w= write/quit   #8. w= write/quit
322   fdisk ${HDD} &> /dev/null << EOF   fdisk ${HDD} &> /dev/null << EOF
323  n  n
324  p  p
325  1  1
# Line 392  a Line 329  a
329  1  1
330  w  w
331  EOF  EOF
332     fi
333     else
334     cfdisk ${HDD} || dialog_die
335   fi   fi
336  }  }
337    
 setup_hdd_partitions_manual()  
 {  
  ROOTHDD="${HDD}1"  
  SWAPHDD=""  
  BOOTHDD=""  
  cfdisk ${HDD} || dialog_die  
 }  
   
338  setup_hdd_format()  setup_hdd_format()
339  {  {
340   # sanity check - should not happen   install -d /tmp
341   if is_mounted --device "${ROOTHDD}"   :> /tmp/format.log
342    
343     if [[ -n ${SWAPHDD} ]]
344   then   then
345   echo "format: device ${ROOTHDD} is already mounted, umount it" >&2   # sanity check - should not happen
346   umount "${ROOTHDD}"   if is_mounted --device "${SWAPHDD}"
347     then
348     echo "format: device ${SWAPHDD} is already mounted, umount it" >&2
349     umount "${SWAPHDD}"
350     fi
351     mkswap ${SWAPHDD} || die
352   fi   fi
353    
354   mkfs."${FORMAT_FILESYSTEM}" -q "${ROOTHDD}" || dialog_die   if [[ -n ${BOOTHDD} ]]
355  }   then
356     # sanity check - should not happen
357     if is_mounted --device "${BOOTHDD}"
358     then
359     echo "format: device ${BOOTHDD} is already mounted, umount it" >&2
360     umount "${BOOTHDD}"
361     fi
362    
363  install_mount_rootfs()   mkfs."${FORMAT_FILESYSTEM}" "${BOOTHDD}" &>> /tmp/format.log || dialog_die
364  {   fi
365   is_mounted --location "${INSTALLROOT}" || mount "${ROOTHDD}" "${INSTALLROOT}"  
366   install -d ${INSTALLROOT}/boot || dialog_die   if [[ -n ${ROOTHDD} ]]
367     then
368     # sanity check - should not happen
369     if is_mounted --device "${ROOTHDD}"
370     then
371     echo "format: device ${ROOTHDD} is already mounted, umount it" >&2
372     umount "${ROOTHDD}"
373     fi
374    
375     mkfs."${FORMAT_FILESYSTEM}" "${ROOTHDD}" &>> /tmp/format.log || dialog_die
376     fi
377  }  }
378    
379  install_system_image()  install_system_image()
380  {  {
381   pushd ${INSTALLROOT} > /dev/null   pushd ${INSTALLROOT} > /dev/null
382   tar xvjpf ${CDROOT}/system/${CDIMAGENAME} -C ${INSTALLROOT}   tar xvjpf ${IMAGEROOT}/${CDIMAGENAME} -C ${INSTALLROOT}
383   popd > /dev/null   popd > /dev/null
384  }  }
385    
# Line 435  install_system_settings() Line 390  install_system_settings()
390   # write fstab   # write fstab
391   CONFIG="${INSTALLROOT}/etc/fstab"   CONFIG="${INSTALLROOT}/etc/fstab"
392   clearconfig   clearconfig
393   addconfig -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1"   if [[ -n ${BOOTHDD} ]]
394     then
395     addconfig -e "UUID=$(get_uuid ${BOOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t1 1"
396     fi
397     if [[ -n ${ROOTHDD} ]]
398     then
399     addconfig -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0"
400     fi
401     if [[ -n ${SWAPHDD} ]]
402     then
403     addconfig -e "UUID='$(get_uuid ${SWAPHDD})'\tswap\tswap\tpri=1\t0 0"
404     fi
405   addconfig -e "proc\t/proc\tproc\tdefaults\t0 0"   addconfig -e "proc\t/proc\tproc\tdefaults\t0 0"
406   addconfig -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0"   addconfig -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0"
407    
# Line 446  install_system_settings() Line 412  install_system_settings()
412   addconfig 'NETWORKING="dhcp"'   addconfig 'NETWORKING="dhcp"'
413    
414   # intel framebuffer quirk   # intel framebuffer quirk
415   if [ -e ${INSTALLROOT}/etc/splash/splash.conf ]   CONFIG="${INSTALLROOT}/etc/splash/splash.conf"
416     if [ -e ${CONFIG} ] && [ -e /proc/fb ]
417   then   then
418   if [ -e /proc/fb ]   if [[ ! -z $(grep 'inteldrmfb' /proc/fb) ]]
419   then   then
420   if [[ ! -z $(grep 'inteldrmfb' /proc/fb) ]]   fbdev=$(grep 'inteldrmfb' /proc/fb | sed 's:\([0-9]\).*:\1:')
421   then   [[ ${fbdev} != 0 ]] && sed -i "s:^\(SPLASH_DEV=\).*:\1\"/dev/fb${fbdev}\":" ${CONFIG} || dialog_die
  fbdev=$(grep 'inteldrmfb' /proc/fb | sed 's:\([0-9]\).*:\1:')  
  if [[ ${fbdev} != 0 ]]  
  then  
  sed -i "s:^\(SPLASH_DEV=\).*:\1\"/dev/fb${fbdev}\":" ${INSTALLROOT}/etc/splash/splash.conf || dialog_die  
  fi  
  fi  
422   fi   fi
423   fi   fi
424  }  }
425    
426  install_umount_rootfs()  
427    ### installer dialogs ###
428    
429    dialog_die()
430  {  {
431   is_mounted --location ${INSTALLROOT}/boot && umount ${INSTALLROOT}/boot   ERROR="$1"
432   is_mounted --location ${INSTALLROOT} && umount ${INSTALLROOT}   RETVAL="$?"
433     dialog_install_failure
434     exit 1
435  }  }
436    
437  install_do_reboot()  dialog_warning()
438  {  {
439   reboot   local retval
440    
441     yesnobox $"\Z1 !!! Warning !!! \Zn\n\n\This harddrive will be irreversibly erased.\n\n\Do you want to continue ?"
442     retval=$?
443     if [[ ${retval} -eq 1 ]]
444     then
445     clear
446     echo $"The process was aborted."
447     exit 1
448     fi
449  }  }
450    
 #################################################  
 #     Install Ablauf Scripte #  
 #################################################  
451    
452  run_install_normal()  ### installer tasks ###
453    
454    task_setup_system_menu()
455  {  {
456   dialog_hardware_detection   local mode
457     local retval
458    
459   task_setup_hdd_partitions_manual   mode="$(dialog_setup_system_menu)"
460   dialog_setup_hdd_format   retval=$?
461   setup_hdd_format > /dev/null   [[ ${retval} -eq 1 ]] && return 1
462   install_mount_rootfs   if [[ ${retval} -eq 0 ]]
463   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | install_meter | dialog_install_system_image   then
464     case "${mode}" in
465     "1") run_install auto ;;
466     "2") run_install normal ;;
467     "") task_setup_system_menu;;
468     esac
469     fi
470    }
471    
472   dialog_install_settings  task_hardware_detection()
473   sleep 1  {
474   install_system_settings   local message
475   if is_initrd_supported  
476     run_hardware_detection_disks
477    
478     message+=$"Harddrives:\n"
479    
480     if [[ ! -z ${ALL_DISKS} ]]
481   then   then
482   dialog_install_initrd   for i in ${ALL_DISKS}
483   initrd_config   do
484   initrd_install   message+="\Z3${i}\Zn "
485     done
486     message+="\n"
487   fi   fi
488    
489   dialog_install_bootsector   if [[ ! -z ${ALL_CDROMS} ]]
490   bootloader_config   then
491   bootloader_install   message+="\n"
492     message+=$"Optical disk drives:\n"
493     for i in ${ALL_CDROMS}
494     do
495     message+="\Z3${i}\Zn"
496     done
497     message+="\n"
498     fi
499    
500   install_umount_rootfs   # other devices
501   dialog_install_successful   run_hardware_detection
502     case "${SPECIALDEVICE}" in
503     zotac*) message+=$"\n\Z2Zotac device detected.\Zn" ;;
504     rangee) message+=$"\n\Z2Rangee device detected.\Zn" ;;
505     maxdata) message+=$"\n\Z2Maxdata device detected.\Zn" ;;
506     *) message+=$"\n\ZnCommon device detected.\Zn" ;;
507     esac
508     if [[ ${FORMFACTOR} = laptop ]]
509     then
510     message+=$"\n\ZnFormfactor Laptop, activating 'ondemand' powersaving mode.\Zn"
511     fi
512    
513     messagebox -y 12 -h $"Detected hardware:" "${message}"
514  }  }
515    
516  run_install_auto()  task_setup_hdd_partitions()
517  {  {
518   dialog_hardware_detection   local i
519     local retval
520    
521     if [[ -z ${ALL_DISKS} ]]
522     then
523     dialog_no_harddrive_found
524     exit 1
525     else
526     HDD=$(dialog_select_target_harddrive)
527     retval=$?
528     [[ ${retval} -eq 1 ]] && return 1
529     if [[ ${retval} -eq 0 ]]
530     then
531     dialog_setup_hdd_info
532     setup_hdd_partitions
533     fi
534     fi
535    }
536    
537    task_main()
538    {
539     local method=0
540     local retval
541    
542     while [[ ${method} -le 2 ]]
543     do
544     method=$(dialog_main)
545     retval=$?
546     [[ ${retval} -eq 1 ]] && exit 1
547     if [[ ${retval} -eq 0 ]]
548     then
549     case ${method} in
550     "1") task_setup_system_menu ;;
551     "2") task_hardware_detection ;;
552     "3") install_do_reboot ;;
553     "4") /bin/bash --login -i ;;
554     esac
555     fi
556     done
557    }
558    
559    run_install()
560    {
561     local method="$1"
562    
563     task_hardware_detection
564    
565     case "${method}" in
566     auto)
567     export INSTALL_METHOD="${method}"
568     ;;
569     normal)
570     export INSTALL_METHOD="${method}"
571     ;;
572     *)
573     die "Unknown install method '${method}', aborting."
574     ;;
575     esac
576    
577   task_setup_hdd_partitions_auto   task_setup_hdd_partitions
578   dialog_setup_hdd_format   dialog_setup_hdd_format
579   setup_hdd_format > /dev/null   setup_hdd_format > /dev/null
580   install_mount_rootfs   mount_rootfs
581   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | install_meter | dialog_install_system_image   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | install_meter | dialog_install_system_image
582    
583   dialog_install_settings   dialog_install_settings
# Line 529  run_install_auto() Line 594  run_install_auto()
594   bootloader_config   bootloader_config
595   bootloader_install   bootloader_install
596    
597   install_umount_rootfs   umount_rootfs
598   dialog_install_successful   dialog_install_successful
599  }  }
600    

Legend:
Removed from v.2480  
changed lines
  Added in v.2883